; Automatically determines the shortest acceptable LCD delay
;
; (C) 2004, Michael Vincent. All rights reserved.
;
.nolist
#include "ti83plus.inc"
#include "mirage.inc"
.list
.org $9D93
#define wait appbackupscreen
#define spot1 wait+2
#define spot2 spot1+2
#define spot3 spot2+2
#define adjust spot3+2
#define initial adjust+2
#define superdelay initial+2
	.db $BB,$6D
	xor a
	jr nc,start
	.db "LCD Speed",0
start:
	ld hl,128
	ld (adjust),hl
	ld hl,250
	ld (initial),hl
ready:
	ld hl,(initial)
	ld (wait),hl
	di
	call display
	jr z,subtract
	ld bc,(adjust)
	ld a,b
	or c
	jr nz,adding
	inc bc
adding:
	ld hl,(initial)
	add hl,bc
	ld (initial),hl
	ld bc,65400
	or a
	sbc hl,bc
	jr c,ready_2
	ld (initial),bc
	jr alldone
subtract:
	ld bc,(adjust)
	ld a,b
	or c
	jr z,alldone
	ld hl,(initial)
	or a
	sbc hl,bc
	ld a,h
	or a
	jr nz,subtract1
	ld a,l
	cp 7
	jr c,alldone_minimum
subtract1:
	ld (initial),hl
	srl b
	rr c
	ld (adjust),bc
ready_2:
	jr ready
alldone_minimum:
	ld hl,7
	ld (initial),hl
alldone:
	bcall(_clrscrnfull)
	bcall(_homeup)
	ld hl,text_1
	bcall(_puts)
	ld hl,(initial)
	ld bc,18
	add hl,bc
	bcall(_disphl)
finalloop:
	bcall(_getcsc)
	or a
	jr z,finalloop
	ei
	ret
text_1:
	.db "Minimum LCD     "
	.db "t-states:",0
display:
	;Copy the first part
	ld hl,lcd_1
	ld de,savesscreen
	ld bc,lcd_1_end-lcd_1
	ldir
	;DE is the next byte...where to put our delay
	call putdelay
	ld a,0D3h
	ld (de),a
	inc de
	ld a,10h
	ld (de),a
	inc de
	call putdelay
	ld hl,lcd_2
	ld bc,lcd_2_end-lcd_2
	ldir
	ld (spot1),de
	call putdelay
	ld (spot3),de
	ld hl,lcd_3
	ld bc,lcd_3_end-lcd_3
	ldir
	ld (spot2),de
	call putdelay
	ld hl,lcd_4
	ld bc,lcd_4_end-lcd_4
	ldir
	;Now we are ready!
	ld de,savesscreen+11
	ld hl,(spot2)
	dec hl
	dec hl
	push hl
	ex de,hl
	or a
	sbc hl,de
	ex de,hl
	pop hl
	dec hl
	ld (hl),e
	ld hl,(spot3)
	inc hl
	inc hl
	inc hl
	inc hl
	ld de,(spot1)
	push hl
	ex de,hl
	or a
	sbc hl,de
	ex de,hl
	dec de
	dec de
	pop hl
	ld (hl),e
	ld b,15
testloop:
	push bc
	ld hl,splash
	call savesscreen
	ld hl,splash
	call comparelcd
	pop bc
	ret nz
	djnz testloop
	xor a
	ret
putdelay:
	;Write in the delay at (wait) to DE
	ld hl,(wait)
	ld bc,100
	or a
	sbc hl,bc
	push af
	add hl,bc
	pop af
	jr c,putdelay2
	ld bc,1
	ld (superdelay),bc
	ld bc,31+25+11+10
	or a
	sbc hl,bc
putdelay3:
	ld bc,50
	or a
	sbc hl,bc
	push af
	add hl,bc
	pop af
	jr c,putdelay4
	ld bc,30
	sbc hl,bc
	ld bc,(superdelay)
	inc bc
	ld (superdelay),bc
	jr putdelay3
putdelay4:
	ld a,$F5	;push af - 11
	ld (de),a
	inc de
	ld a,$C5	;push bc - 11
	ld (de),a
	inc de
	ld a,1
	ld (de),a
	inc de		;ld bc,xxxx - 10
	ld a,(superdelay)
	ld (de),a
	inc de
	ld a,(superdelay+1)
	ld (de),a
	inc de
	xor a
	ld (de),a	;nop - 4
	inc de
	ld a,0Bh	;dec bc - 6
	ld (de),a
	inc de
	ld a,78h	;ld a,b - 4
	ld (de),a
	inc de
	ld a,$B1	;or c - 4
	ld (de),a
	inc de
	ld a,20h
	ld (de),a	;jr  7/12
	inc de
	ld a,$FA
	ld (de),a
	inc de
	ld a,$C1	;pop bc - 10
	ld (de),a
	inc de
	ld a,$F1	;pop af - 10
	ld (de),a
	inc de
putdelay2:
	ld a,l
	and %00000011
	jr z,noodd
	cp 1
	jr z,delay1
	cp 2
	jr z,delay2
	;3
	ld a,4Eh
	ld (de),a
	inc de
	ld bc,7
	or a
	sbc hl,bc
	jr noodd
delay1:
	xor a
	ld (de),a
	inc de
	ld a,$D8
	ld (de),a
	inc de
	ld bc,9
	or a
	sbc hl,bc
	jr noodd
delay2:
	ld a,0DDh
	ld (de),a
	inc de
	ld a,23h
	ld (de),a
	inc de
	ld bc,10
	or a
	sbc hl,bc
noodd:
	ld a,h
	or l
	ret z
	xor a
	ld (de),a
	inc de
	ld bc,4
	or a
	sbc hl,bc
	jr nz,noodd
	ret
lcd_1:
	ld de,OP1
	or a
	ld b,64
	ld a,07h
	out (10h),a
	ld a,80h-1
layerloop1:
	push bc
	ld b,0Ch
	inc a
	ld (de),a
lcd_1_end:
lcd_2:
	ld a,20h
	out (10h),a
layerloop2:
	ld a,(hl)
lcd_2_end:
lcd_3:
	out (11h),a
	inc hl
lcd_adjust1:
	djnz layerloop2
	pop bc
	ld a,(de)
lcd_adjust2:
	djnz layerloop1
	ld a,5
lcd_3_end:
lcd_4:
	out (10h),a
	ret
lcd_4_end:
splash:
	.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$1C,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$63,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$90,$81
	.db $80,$18,$DB,$C7,$1E,$F8,$71,$E0,$00,$01,$20,$41
	.db $80,$1D,$DB,$6D,$B0,$C0,$8A,$00,$00,$01,$40,$41
	.db $80,$1F,$DB,$CF,$B6,$F0,$89,$C0,$00,$02,$40,$21
	.db $80,$1A,$DB,$6D,$B6,$C0,$88,$20,$00,$02,$00,$21
	.db $80,$18,$DB,$6D,$9E,$F8,$73,$C0,$00,$02,$00,$21
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$01,$00,$41
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$01,$00,$41
	.db $80,$00,$00,$00,$00,$04,$00,$43,$00,$00,$80,$81
	.db $80,$00,$00,$02,$92,$B0,$98,$C0,$80,$00,$63,$01
	.db $80,$00,$00,$02,$AB,$25,$54,$41,$00,$00,$1C,$01
	.db $80,$00,$00,$01,$32,$15,$54,$42,$00,$00,$00,$01
	.db $80,$00,$00,$01,$1A,$34,$94,$EB,$80,$00,$00,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $80,$00,$01,$FF,$FF,$00,$00,$00,$00,$00,$00,$01
	.db $80,$00,$1F,$FF,$C0,$FC,$00,$00,$00,$00,$00,$01
	.db $80,$0F,$FF,$F0,$00,$03,$E0,$00,$00,$00,$00,$01
	.db $87,$FF,$FE,$00,$00,$00,$1E,$00,$00,$00,$00,$01
	.db $FF,$FF,$E0,$00,$00,$00,$01,$E0,$00,$00,$00,$01
	.db $FF,$FC,$00,$00,$00,$00,$00,$1F,$80,$00,$00,$01
	.db $FE,$00,$00,$00,$00,$00,$00,$00,$7F,$C0,$00,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$3F,$FF,$FF
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$1A,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$7F,$61
	.db $80,$00,$00,$FF,$C0,$00,$00,$3F,$80,$00,$9F,$F9
	.db $80,$00,$0F,$FC,$3F,$00,$03,$FC,$78,$00,$2F,$F5
	.db $80,$01,$FF,$C0,$00,$F0,$1F,$E0,$07,$80,$2D,$E9
	.db $80,$3F,$F8,$00,$00,$0F,$FE,$00,$00,$70,$0E,$C9
	.db $87,$FF,$80,$00,$00,$00,$7F,$80,$00,$0F,$8C,$C1
	.db $FF,$FC,$00,$00,$00,$00,$00,$78,$00,$00,$0C,$C1
	.db $FF,$E0,$00,$00,$00,$00,$00,$00,$00,$00,$0C,$C1
	.db $FE,$00,$00,$00,$00,$00,$00,$00,$00,$00,$1C,$C1
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$7F,$FD,$C1
	.db $80,$00,$00,$00,$00,$00,$00,$00,$3F,$80,$03,$E1
	.db $80,$00,$00,$00,$00,$00,$00,$07,$C0,$00,$00,$11
	.db $81,$80,$04,$00,$04,$60,$00,$08,$00,$00,$00,$11
	.db $81,$54,$8D,$4C,$8C,$55,$40,$08,$00,$00,$1F,$E1
	.db $81,$99,$55,$51,$54,$65,$00,$07,$E0,$1F,$E0,$01
	.db $81,$11,$55,$51,$94,$52,$40,$00,$1F,$E0,$00,$01
	.db $81,$10,$8D,$CC,$CC,$64,$00,$00,$00,$00,$00,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $81,$9D,$C8,$D5,$D8,$32,$45,$77,$26,$30,$00,$01
	.db $81,$50,$95,$15,$14,$45,$45,$22,$55,$40,$00,$01
	.db $81,$58,$9D,$1D,$94,$25,$45,$22,$55,$20,$00,$01
	.db $81,$50,$95,$15,$14,$15,$45,$22,$55,$10,$00,$01
	.db $81,$9C,$94,$D5,$D8,$62,$77,$27,$25,$60,$00,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
	.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
menu:
	.db "1) 6 MHz        "
	.db "2) 15 MHz",0
comparelcd:
	ld b,64
	ld a,07h
	out (10h),a
	ld a,80h-1
Slayerloop1:
	push bc
	ld b,0Ch
	inc a
	ld (OP1),a
	call lcddelay
	out (10h),a
	call lcddelay
	ld a,20h
	out (10h),a
	call lcddelay
	in a,(11h)
Slayerloop2:
	call lcddelay
	in a,(11h)
	cp (hl)
	jr nz,comparelcd_exit
	inc hl
	djnz Slayerloop2
	pop bc
	ld a,(OP1)
	djnz Slayerloop1
	ld a,05h
	call lcddelay
	out (10h),a
	xor a
	ret
comparelcd_exit:
	pop bc
	ret
lcddelay:
	push af
lcddelayloop:
	in a,(2)
	and 2
	jr z,lcddelayloop
	pop af
	ret
.end
